#include "da7394.h"


void da7394_init (void)
{
	/*SPE = enable SPI; MSTR = master mode*/
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0);
		
	/*configure pins on port for communication*/
	DA_DDR = (1<<DA_OUT0) | (1<<DA_CS) | (1<<DA_SS) |(1<<DA_MOSI) | (1<<DA_CLK);
	DA_PORT = (1<<DA_OUT0) | (1<<DA_CS) | (1<<DA_SS);
}


void da7394_set_value (unsigned char pin, unsigned short value)
{	
	da7394_init ();
	/*select device*/
	DA_PORT &= ~(1<<DA_CS);
	/*send high byte*/
	SPDR = (value >> 8);
	/*wait, until transmission is completed*/
	while(!(SPSR & (1<<SPIF)));
	/*send low byte*/
	SPDR = value;
	/*wait, until transmission is completed*/
	while(!(SPSR & (1<<SPIF)));
	/*deselect device*/
	DA_PORT |= (1<<DA_CS);
	/*choose channel for output*/
	switch (pin)
	{
	case 0: DA_PORT &= ~(1<<DA_OUT0);
			asm volatile ("nop");
			DA_PORT |= (1<<DA_OUT0);
			break;
	case 1: DA_PORT &= ~(1<<DA_OUT1);
			asm volatile ("nop");
			DA_PORT |= (1<<DA_OUT1);
			break;
	case 2: DA_PORT = ~(1<<DA_OUT0) & ~(1<<DA_OUT1);
			asm volatile ("nop");
			DA_PORT = (1<<DA_OUT0) | (1<<DA_OUT1);
			break;
	}
}
